#!/usr/bin/perl

use strict;

my $exe = "scm";

my $seed = 0;

my $envType = "datasetEnv";
my $Psize = 16;
my $Msize = 16;
my $pd = 0.1;
my $pa = 0.1;
my $mua = 0.1;
my $omega = 9;
my $t = 1000;
my $Pgap = 4;
my $Mgap = 4;

my $trainSetName = "ann-train.data";
my $testSetName = "ann-test.data";
my $trainSetSize = 3772;
my $testSetSize = 3428;
my $setDim = 21;
my $maxProgSize = 48;
my $pBidMutate = 0.1;
my $pBidSwap = 0.1;
my $pBidDelete = 0.1;
my $pBidAdd = 0.1;

my $statMod = 10;

if(scalar(@ARGV) != 2)
{
    die "usage: genScript.pl prefix numRuns";
}

my $prefix = $ARGV[0];
my $numRuns = $ARGV[1];

print "prefix: $prefix\n";
print "numRuns: $numRuns\n";

my $run;
my $argFile;
my $nextSeed;

open(RUN, ">$prefix" . ".run") || die "cannot open RUN $prefix.run";

for($run = 0; $run < $numRuns; $run++)
{
    $nextSeed = $seed+ $run;

    $argFile = "$prefix.$nextSeed.arg";
    
    open(ARG, ">$argFile") || die "cannot open $argFile";

    print ARG "seed $nextSeed\n";
    print ARG "\n";

    print ARG "envType $envType\n";
    print ARG "Psize $Psize\n";
    print ARG "Msize $Msize\n";
    print ARG "pd $pd\n";
    print ARG "pa $pa\n";
    print ARG "mua $mua\n";
    print ARG "omega $omega\n";
    print ARG "t $t\n";
    print ARG "Pgap $Pgap\n";
    print ARG "Mgap $Mgap\n";
    print ARG "\n";

    print ARG "trainSetName $trainSetName\n";
    print ARG "testSetName $testSetName\n";
    print ARG "trainSetSize $trainSetSize\n";
    print ARG "testSetSize $testSetSize\n";
    print ARG "setDim $setDim\n";
    print ARG "maxProgSize $maxProgSize\n";
    print ARG "pBidMutate $pBidMutate\n";
    print ARG "pBidSwap $pBidSwap\n";
    print ARG "pBidDelete $pBidDelete\n";
    print ARG "pBidAdd $pBidAdd\n";
    print ARG "\n";
    
    print ARG "statMod $statMod\n";
    
    close(ARG);
    
    print RUN "./$exe $argFile 1> $prefix.$nextSeed.std 2> $prefix.$nextSeed.err\n";
}

close(RUN);

